/* The Netlogon Project

   unfixmac.c - unfix ethernet adress <--> IP address using "arp"
   
   $Id: unfixmac.c,v 1.3 2001/03/08 14:54:51 kent Exp $
   
   Copyright (C) 2000,2001 UNIT, Linkping University
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include <stdio.h>

main(int argc, char **argv)
{
  int i;
  char *args[5];
  char *env[] = {NULL};

  /* Argument count */

  if (argc != 2)
    {
      exit(1);
    }

  /* Argument length */

  for (i=1; i<=1; i++)
    {
      if (strlen(argv[i]) > 32)
	{
	  exit(1);
	}
    }

  /* FIXME: should check IP syntax.
     We accept the fact that a bad guy could mess freely with arp */

  args[0] = "/sbin/arp";
  args[1] = "-d";
  args[2] = argv[1];
  args[3] = NULL;

  if (execve(args[0], args, env) <0)
    {
      exit(1);
    }

  exit(0);
}
