Name:           netlogon
Summary:        Network Logon
Version:        1.2
Release:        1
Copyright:      GPL
Group:          System Environment/Base
Source:         netlogon-1.2.tar.gz
Vendor:         UNIT
Distribution:   UNIT Netlogon
Packager:       Kent Engstrm <kent@unit.liu.se>

%description
Netlogon is a Linux based system for authenticating network users
before they are allowed to communicate. A Linux box acts as a firewall
and demands that users logon using a web page.

%prep
%setup

%build
make

%install
make install

%files
/opt/netlogon/bin
%config /opt/netlogon/conf/auth.conf
%config /opt/netlogon/conf/general.conf
%config /opt/netlogon/conf/interfaces.conf
%config /opt/netlogon/conf/language.conf
%config /opt/netlogon/conf/switches.conf
/opt/netlogon/cron
%dir /opt/netlogon/dhcp
/opt/netlogon/dns
/opt/netlogon/httpd/conf
%dir /opt/netlogon/httpd/logs
%dir /opt/netlogon/httpd/ssl
/opt/netlogon/httpd/root
/opt/netlogon/httpd/templates
/opt/netlogon/lib
%dir /opt/netlogon/pid
%dir /opt/netlogon/rrdtool
/opt/netlogon/sock
%dir /opt/netlogon/syslog
/etc/rc.d/init.d/netlogon-conf
/etc/rc.d/init.d/netlogon-firewall
/etc/rc.d/init.d/netlogon-dhcpd
/etc/rc.d/init.d/netlogon-named
/etc/rc.d/init.d/netlogon-httpd
/etc/rc.d/init.d/netlogon-clear-database
/etc/rc.d/init.d/netlogon-ledd
%doc COPYING
%doc README
%doc doc/CHANGES
%doc doc/LED
%doc doc/TODO
%post
echo "[modifying system startup (/etc/rc.d)]"
/sbin/chkconfig netlogon-conf on
/sbin/chkconfig netlogon-firewall on
/sbin/chkconfig netlogon-dhcpd on
/sbin/chkconfig dhcpd off
/sbin/chkconfig netlogon-named on
/sbin/chkconfig named off
/sbin/chkconfig netlogon-httpd on
/sbin/chkconfig httpd off
/sbin/chkconfig netlogon-clear-database on
/sbin/chkconfig netlogon-ledd on
echo "[installing crontab]"
crontab -u netlogon /opt/netlogon/cron/netlogon.crontab
