# The Netlogon Project
#
# path.py - directories and paths
#
# $Id: path.py,v 1.7 2001/03/08 14:54:51 kent Exp $
#
# Copyright (C) 2000,2001 UNIT, Linkping University
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# Directories
import os

basedir = "/opt/netlogon"
confdir =  os.path.join(basedir, "conf")
bindir  =  os.path.join(basedir, "bin")
libdir  =  os.path.join(basedir, "lib")
dhcpdir  =  os.path.join(basedir, "dhcp")
httpddir  =  os.path.join(basedir, "httpd")
templatedir  =  os.path.join(httpddir, "templates")
httpdconfdir  =  os.path.join(httpddir, "conf")
syslogdir  =  os.path.join(basedir, "syslog")
piddir = os.path.join(basedir, "pid")
rrddir = os.path.join(basedir, "rrdtool")

# Path
import sys
sys.path.insert(0, libdir)
